var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { KMS } from 'aws-sdk';
const kms = new KMS();
export const dictionary = new Map();
function encrypt({ plaintext, keyId, }) {
    return __awaiter(this, void 0, void 0, function* () {
        const result = yield kms
            .encrypt({ KeyId: keyId, Plaintext: plaintext })
            .promise();
        const ciphertext = result.CiphertextBlob
            ? result.CiphertextBlob.toString('base64')
            : plaintext;
        return dictionary.set(plaintext, ciphertext) && ciphertext;
    });
}
export default ({ plaintext, keyId, }) => process.env.DISABLE_AWS_KMS_THINGY
    ? String(plaintext)
    :
        dictionary.get(keyId + plaintext) ||
            encrypt({ plaintext, keyId });
