var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { decrypt, encrypt } from './';
const mockDecryptedValue = 'foobar';
const mockEncryptedValue = Buffer.from(mockDecryptedValue).toString('base64');
const mockArrayOfDecryptedValues = [
    'foobar-1',
    'foobar-2',
    'foobar-3',
    'foobar-4',
];
const mockArrayOfEncryptedValues = [
    Buffer.from(mockArrayOfDecryptedValues[0]).toString('base64'),
    Buffer.from(mockArrayOfDecryptedValues[1]).toString('base64'),
    Buffer.from(mockArrayOfDecryptedValues[2]).toString('base64'),
    Buffer.from(mockArrayOfDecryptedValues[3]).toString('base64'),
];
describe('lib', () => {
    it('should encrypt an string', () => __awaiter(this, void 0, void 0, function* () {
        const result = yield encrypt({
            keyId: 'foobar-key',
            plaintext: mockDecryptedValue,
        });
        expect(result).toBe(mockEncryptedValue);
    }));
    it('should encrypt an array of strings', () => __awaiter(this, void 0, void 0, function* () {
        const result = yield encrypt(mockArrayOfDecryptedValues.map(item => ({
            keyId: 'foobar-key',
            plaintext: item,
        })));
        expect(result).toEqual(mockArrayOfEncryptedValues);
    }));
    it('should decrypt an encrypted string', () => __awaiter(this, void 0, void 0, function* () {
        const result = yield decrypt(mockEncryptedValue);
        expect(result).toBe(mockDecryptedValue);
    }));
    it('should decrypt an array of encrypted strings', () => __awaiter(this, void 0, void 0, function* () {
        const result = yield decrypt(mockArrayOfEncryptedValues);
        expect(result).toEqual(mockArrayOfDecryptedValues);
    }));
    it('should be able to handle empty or undefined parameters', () => __awaiter(this, void 0, void 0, function* () {
        expect(yield decrypt(undefined)).toBe(undefined);
        expect(yield decrypt('')).toBe('');
    }));
});
